abstract sig Index { cell_value : Index -> Index}
abstract sig SubIndex1, SubIndex2, SubIndex3 extends Index {}
one sig One, Two, Three extends SubIndex1 {}
one sig Four, Five, Six extends SubIndex2 {}
one sig Seven, Eight, Nine extends SubIndex3 {}

fact{
// rows contain all numbers
all row: Index | Index in Index.(row.cell_value)
// columns contain all numbers
all column: Index | Index in column.(Index.cell_value)
// each cell has only 1 value
all x, y: Index | lone y.(x.cell_value)

// subsquares contain all numbers
Index in SubIndex1.(SubIndex1.cell_value)
Index in SubIndex1.(SubIndex2.cell_value)
Index in SubIndex1.(SubIndex3.cell_value)
Index in SubIndex2.(SubIndex1.cell_value)
Index in SubIndex2.(SubIndex2.cell_value)
Index in SubIndex2.(SubIndex3.cell_value)
Index in SubIndex3.(SubIndex1.cell_value)
Index in SubIndex3.(SubIndex2.cell_value)
Index in SubIndex3.(SubIndex3.cell_value)
}

//one b: Book | one c, cc: Couple | c.brought = b and cc.taken = b and c.last


fact{
One->One->One + One->Four->Two + One->Seven->Three +
Two->Two->Two + Two->Five->Three + Two->Eight->Four + 
Three->Three->Three + Three->Six->Four + Three->Nine->Five + 
Four->One->Six + Four->Four->Four + Four->Seven->Five +
Five->Two->Seven + Five->Five->Five + Five->Eight->Six + 
Six->Three->Eight + Six->Six->Six + Six->Nine->Seven + 
Seven->One->Eight + Seven->Four->Nine + Seven->Seven->Seven +
Eight->Two->Nine + Eight->Five->One + Eight->Eight->Eight + 
Nine->Three->One + Nine->Six->Two + Nine->Nine->Four in cell_value
}

run {}
